# coding: utf-8

"""
    BOAVIZTAPI - DEMO

    <p>🎯 Retrieving the impacts of digital elements.</p> <p>This is a quick demo, to see full documentation <a href=\"https://doc.api.boavizta.org\">click here</a></p> <h2>Features</h2> <p>Bellow a list of all available features.</p> <h3>👄 Verbose</h3> <p>Verbose is an HTTP parameter. If set at true :</p> <ul> <li>Shows the impacts of each component</li> <li>Shows the value used for each attribute</li> </ul> <p><em>\"attribute\": {\"value\": \"value\", \"unit\": \"unit\", \"status\": \"Status\", \"source\": \"Source\", \"min\":\"min\", \"max\":\"max\", \"significant_figures\":\"significant_figures\"}</em></p> <h3>🔨 Embedded</h3> <ul> <li>Embedded impacts are the impacts occurring during raw material extraction, manufacture, distribution and end of life</li> <li>When end of life is not taken into account, we specified it in the <code>warnings</code></li> </ul> <h3>🔌  Usage</h3> <p>Usage impacts are assessed by multiplying :</p> <ul> <li> <p>a <strong>duration</strong></p> </li> <li> <p>an <strong>impact factor</strong> </p> </li> <li> <p>an <strong>electrical consumption</strong> </p> </li> </ul> <h4>⏲ Duration</h4> <p>Usage impacts can be given as a router parameter, in hours.</p> <p>If no duration is given, <strong>the impact is assess for the all life duration of the asset</strong>.</p> <h4>✖️ Impact factors</h4> <ul> <li>Impact factors can be given : <em>\"usage\":{\"elec_factors\":{[criterion]_factors: 0.38}}</em></li> <li> <p>Impact factors can be retrieved from : <em>\"usage\":{\"usage_location\": \"FRA\"}</em>. </p> </li> <li> <p>See the list of locations : <a href=\"/v1/utils/country_code\">/v1/utils/country_code</a>*</p> </li> </ul> <h4>⚡ Electrical consumption</h4> <h5>⏺️ Given</h5> <ul> <li>Electrical consumption can be given for one hour (average) <em>\"usage\":{\"avg_power\": 1}</em>.</li> </ul> <h5>📈 Modeled</h5> <ul> <li>Electrical consumption can be retrieved from consumption profile using <em>usage:{time_workload: 50}</em>.</li> </ul> <h5>📋 Archetype</h5> <ul> <li>In some cases, default electrical consumption can be taken from the archetype</li> </ul> <h3>🔃 Auto-complete &amp; 📋 Archetype</h3> <p>The API will complete the missing attributes in a request with a completion function or with values taken from the <code>archetype</code> specified in the route parameter.</p> <h3>⏬ Allocation</h3> <ul> <li>Usage impacts are assessed on the duration given in route parameter</li> <li>Embedded impacts are allocated linearly on the duration given in parameter <code>embedded_impact = impact * (duration/life_duration)</code></li> </ul> <p>If no duration is given, the life_duration (<code>`hours_life_time</code>) of the asset is used.</p>  # noqa: E501

    The version of the OpenAPI document: 1.0.0a4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError
from typing_extensions import Annotated

from pydantic import StrictBool, StrictFloat, StrictInt, StrictStr, conlist

from typing import Any, Optional, Union

from boaviztapi_sdk.models.external_hdd import ExternalHDD
from boaviztapi_sdk.models.external_ssd import ExternalSSD
from boaviztapi_sdk.models.monitor import Monitor
from boaviztapi_sdk.models.usb_stick import UsbStick

from boaviztapi_sdk.api_client import ApiClient
from boaviztapi_sdk.api_response import ApiResponse
from boaviztapi_sdk.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class PeripheralApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def external_hdd_get_all_archetype_name_v1_peripheral_external_hdd_archetypes_get(self, **kwargs) -> object:  # noqa: E501
        """External Hdd Get All Archetype Name  # noqa: E501

        # ✔️ Get all the available user terminal archetype for a given user terminal name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_hdd_get_all_archetype_name_v1_peripheral_external_hdd_archetypes_get(async_req=True)
        >>> result = thread.get()

        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the external_hdd_get_all_archetype_name_v1_peripheral_external_hdd_archetypes_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.external_hdd_get_all_archetype_name_v1_peripheral_external_hdd_archetypes_get_with_http_info(**kwargs)  # noqa: E501

    @validate_arguments
    def external_hdd_get_all_archetype_name_v1_peripheral_external_hdd_archetypes_get_with_http_info(self, **kwargs) -> ApiResponse:  # noqa: E501
        """External Hdd Get All Archetype Name  # noqa: E501

        # ✔️ Get all the available user terminal archetype for a given user terminal name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_hdd_get_all_archetype_name_v1_peripheral_external_hdd_archetypes_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method external_hdd_get_all_archetype_name_v1_peripheral_external_hdd_archetypes_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
        }

        return self.api_client.call_api(
            '/v1/peripheral/external_hdd/archetypes', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def external_hdd_get_archetype_config_v1_peripheral_external_hdd_archetype_config_get(self, archetype : StrictStr, **kwargs) -> object:  # noqa: E501
        """External Hdd Get Archetype Config  # noqa: E501

        # ✔️ Get the configuration of a given archetype  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_hdd_get_archetype_config_v1_peripheral_external_hdd_archetype_config_get(archetype, async_req=True)
        >>> result = thread.get()

        :param archetype: (required)
        :type archetype: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the external_hdd_get_archetype_config_v1_peripheral_external_hdd_archetype_config_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.external_hdd_get_archetype_config_v1_peripheral_external_hdd_archetype_config_get_with_http_info(archetype, **kwargs)  # noqa: E501

    @validate_arguments
    def external_hdd_get_archetype_config_v1_peripheral_external_hdd_archetype_config_get_with_http_info(self, archetype : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """External Hdd Get Archetype Config  # noqa: E501

        # ✔️ Get the configuration of a given archetype  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_hdd_get_archetype_config_v1_peripheral_external_hdd_archetype_config_get_with_http_info(archetype, async_req=True)
        >>> result = thread.get()

        :param archetype: (required)
        :type archetype: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'archetype'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method external_hdd_get_archetype_config_v1_peripheral_external_hdd_archetype_config_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('archetype') is not None:  # noqa: E501
            _query_params.append(('archetype', _params['archetype']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/v1/peripheral/external_hdd/archetype_config', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def external_hdd_impact_v1_peripheral_external_hdd_get(self, archetype : Optional[StrictStr] = None, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, criteria : Optional[conlist(StrictStr)] = None, **kwargs) -> object:  # noqa: E501
        """External Hdd Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_hdd_impact_v1_peripheral_external_hdd_get(archetype, verbose, duration, criteria, async_req=True)
        >>> result = thread.get()

        :param archetype:
        :type archetype: str
        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param criteria:
        :type criteria: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the external_hdd_impact_v1_peripheral_external_hdd_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.external_hdd_impact_v1_peripheral_external_hdd_get_with_http_info(archetype, verbose, duration, criteria, **kwargs)  # noqa: E501

    @validate_arguments
    def external_hdd_impact_v1_peripheral_external_hdd_get_with_http_info(self, archetype : Optional[StrictStr] = None, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, criteria : Optional[conlist(StrictStr)] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """External Hdd Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_hdd_impact_v1_peripheral_external_hdd_get_with_http_info(archetype, verbose, duration, criteria, async_req=True)
        >>> result = thread.get()

        :param archetype:
        :type archetype: str
        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param criteria:
        :type criteria: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'archetype',
            'verbose',
            'duration',
            'criteria'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method external_hdd_impact_v1_peripheral_external_hdd_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('archetype') is not None:  # noqa: E501
            _query_params.append(('archetype', _params['archetype']))

        if _params.get('verbose') is not None:  # noqa: E501
            _query_params.append(('verbose', _params['verbose']))

        if _params.get('duration') is not None:  # noqa: E501
            _query_params.append(('duration', _params['duration']))

        if _params.get('criteria') is not None:  # noqa: E501
            _query_params.append(('criteria', _params['criteria']))
            _collection_formats['criteria'] = 'multi'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/v1/peripheral/external_hdd', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def external_hdd_impact_v1_peripheral_external_hdd_post(self, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, archetype : Optional[StrictStr] = None, criteria : Optional[conlist(StrictStr)] = None, external_hdd : Optional[ExternalHDD] = None, **kwargs) -> object:  # noqa: E501
        """External Hdd Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_hdd_impact_v1_peripheral_external_hdd_post(verbose, duration, archetype, criteria, external_hdd, async_req=True)
        >>> result = thread.get()

        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param archetype:
        :type archetype: str
        :param criteria:
        :type criteria: List[str]
        :param external_hdd:
        :type external_hdd: ExternalHDD
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the external_hdd_impact_v1_peripheral_external_hdd_post_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.external_hdd_impact_v1_peripheral_external_hdd_post_with_http_info(verbose, duration, archetype, criteria, external_hdd, **kwargs)  # noqa: E501

    @validate_arguments
    def external_hdd_impact_v1_peripheral_external_hdd_post_with_http_info(self, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, archetype : Optional[StrictStr] = None, criteria : Optional[conlist(StrictStr)] = None, external_hdd : Optional[ExternalHDD] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """External Hdd Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_hdd_impact_v1_peripheral_external_hdd_post_with_http_info(verbose, duration, archetype, criteria, external_hdd, async_req=True)
        >>> result = thread.get()

        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param archetype:
        :type archetype: str
        :param criteria:
        :type criteria: List[str]
        :param external_hdd:
        :type external_hdd: ExternalHDD
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'verbose',
            'duration',
            'archetype',
            'criteria',
            'external_hdd'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method external_hdd_impact_v1_peripheral_external_hdd_post" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('verbose') is not None:  # noqa: E501
            _query_params.append(('verbose', _params['verbose']))

        if _params.get('duration') is not None:  # noqa: E501
            _query_params.append(('duration', _params['duration']))

        if _params.get('archetype') is not None:  # noqa: E501
            _query_params.append(('archetype', _params['archetype']))

        if _params.get('criteria') is not None:  # noqa: E501
            _query_params.append(('criteria', _params['criteria']))
            _collection_formats['criteria'] = 'multi'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['external_hdd'] is not None:
            _body_params = _params['external_hdd']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/v1/peripheral/external_hdd', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def external_ssd_get_all_archetype_name_v1_peripheral_external_ssd_archetypes_get(self, **kwargs) -> object:  # noqa: E501
        """External Ssd Get All Archetype Name  # noqa: E501

        # ✔️ Get all the available user terminal archetype for a given user terminal name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_ssd_get_all_archetype_name_v1_peripheral_external_ssd_archetypes_get(async_req=True)
        >>> result = thread.get()

        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the external_ssd_get_all_archetype_name_v1_peripheral_external_ssd_archetypes_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.external_ssd_get_all_archetype_name_v1_peripheral_external_ssd_archetypes_get_with_http_info(**kwargs)  # noqa: E501

    @validate_arguments
    def external_ssd_get_all_archetype_name_v1_peripheral_external_ssd_archetypes_get_with_http_info(self, **kwargs) -> ApiResponse:  # noqa: E501
        """External Ssd Get All Archetype Name  # noqa: E501

        # ✔️ Get all the available user terminal archetype for a given user terminal name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_ssd_get_all_archetype_name_v1_peripheral_external_ssd_archetypes_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method external_ssd_get_all_archetype_name_v1_peripheral_external_ssd_archetypes_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
        }

        return self.api_client.call_api(
            '/v1/peripheral/external_ssd/archetypes', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def external_ssd_get_archetype_config_v1_peripheral_external_ssd_archetype_config_get(self, archetype : StrictStr, **kwargs) -> object:  # noqa: E501
        """External Ssd Get Archetype Config  # noqa: E501

        # ✔️ Get the configuration of a given archetype  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_ssd_get_archetype_config_v1_peripheral_external_ssd_archetype_config_get(archetype, async_req=True)
        >>> result = thread.get()

        :param archetype: (required)
        :type archetype: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the external_ssd_get_archetype_config_v1_peripheral_external_ssd_archetype_config_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.external_ssd_get_archetype_config_v1_peripheral_external_ssd_archetype_config_get_with_http_info(archetype, **kwargs)  # noqa: E501

    @validate_arguments
    def external_ssd_get_archetype_config_v1_peripheral_external_ssd_archetype_config_get_with_http_info(self, archetype : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """External Ssd Get Archetype Config  # noqa: E501

        # ✔️ Get the configuration of a given archetype  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_ssd_get_archetype_config_v1_peripheral_external_ssd_archetype_config_get_with_http_info(archetype, async_req=True)
        >>> result = thread.get()

        :param archetype: (required)
        :type archetype: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'archetype'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method external_ssd_get_archetype_config_v1_peripheral_external_ssd_archetype_config_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('archetype') is not None:  # noqa: E501
            _query_params.append(('archetype', _params['archetype']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/v1/peripheral/external_ssd/archetype_config', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def external_ssd_impact_v1_peripheral_external_ssd_get(self, archetype : Optional[StrictStr] = None, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, criteria : Optional[conlist(StrictStr)] = None, **kwargs) -> object:  # noqa: E501
        """External Ssd Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_ssd_impact_v1_peripheral_external_ssd_get(archetype, verbose, duration, criteria, async_req=True)
        >>> result = thread.get()

        :param archetype:
        :type archetype: str
        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param criteria:
        :type criteria: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the external_ssd_impact_v1_peripheral_external_ssd_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.external_ssd_impact_v1_peripheral_external_ssd_get_with_http_info(archetype, verbose, duration, criteria, **kwargs)  # noqa: E501

    @validate_arguments
    def external_ssd_impact_v1_peripheral_external_ssd_get_with_http_info(self, archetype : Optional[StrictStr] = None, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, criteria : Optional[conlist(StrictStr)] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """External Ssd Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_ssd_impact_v1_peripheral_external_ssd_get_with_http_info(archetype, verbose, duration, criteria, async_req=True)
        >>> result = thread.get()

        :param archetype:
        :type archetype: str
        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param criteria:
        :type criteria: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'archetype',
            'verbose',
            'duration',
            'criteria'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method external_ssd_impact_v1_peripheral_external_ssd_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('archetype') is not None:  # noqa: E501
            _query_params.append(('archetype', _params['archetype']))

        if _params.get('verbose') is not None:  # noqa: E501
            _query_params.append(('verbose', _params['verbose']))

        if _params.get('duration') is not None:  # noqa: E501
            _query_params.append(('duration', _params['duration']))

        if _params.get('criteria') is not None:  # noqa: E501
            _query_params.append(('criteria', _params['criteria']))
            _collection_formats['criteria'] = 'multi'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/v1/peripheral/external_ssd', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def external_ssd_impact_v1_peripheral_external_ssd_post(self, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, archetype : Optional[StrictStr] = None, criteria : Optional[conlist(StrictStr)] = None, external_ssd : Optional[ExternalSSD] = None, **kwargs) -> object:  # noqa: E501
        """External Ssd Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_ssd_impact_v1_peripheral_external_ssd_post(verbose, duration, archetype, criteria, external_ssd, async_req=True)
        >>> result = thread.get()

        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param archetype:
        :type archetype: str
        :param criteria:
        :type criteria: List[str]
        :param external_ssd:
        :type external_ssd: ExternalSSD
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the external_ssd_impact_v1_peripheral_external_ssd_post_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.external_ssd_impact_v1_peripheral_external_ssd_post_with_http_info(verbose, duration, archetype, criteria, external_ssd, **kwargs)  # noqa: E501

    @validate_arguments
    def external_ssd_impact_v1_peripheral_external_ssd_post_with_http_info(self, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, archetype : Optional[StrictStr] = None, criteria : Optional[conlist(StrictStr)] = None, external_ssd : Optional[ExternalSSD] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """External Ssd Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.external_ssd_impact_v1_peripheral_external_ssd_post_with_http_info(verbose, duration, archetype, criteria, external_ssd, async_req=True)
        >>> result = thread.get()

        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param archetype:
        :type archetype: str
        :param criteria:
        :type criteria: List[str]
        :param external_ssd:
        :type external_ssd: ExternalSSD
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'verbose',
            'duration',
            'archetype',
            'criteria',
            'external_ssd'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method external_ssd_impact_v1_peripheral_external_ssd_post" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('verbose') is not None:  # noqa: E501
            _query_params.append(('verbose', _params['verbose']))

        if _params.get('duration') is not None:  # noqa: E501
            _query_params.append(('duration', _params['duration']))

        if _params.get('archetype') is not None:  # noqa: E501
            _query_params.append(('archetype', _params['archetype']))

        if _params.get('criteria') is not None:  # noqa: E501
            _query_params.append(('criteria', _params['criteria']))
            _collection_formats['criteria'] = 'multi'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['external_ssd'] is not None:
            _body_params = _params['external_ssd']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/v1/peripheral/external_ssd', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def monitor_get_all_archetype_name_v1_peripheral_monitor_archetypes_get(self, **kwargs) -> object:  # noqa: E501
        """Monitor Get All Archetype Name  # noqa: E501

        # ✔️ Get all the available user terminal archetype for a given user terminal name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.monitor_get_all_archetype_name_v1_peripheral_monitor_archetypes_get(async_req=True)
        >>> result = thread.get()

        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the monitor_get_all_archetype_name_v1_peripheral_monitor_archetypes_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.monitor_get_all_archetype_name_v1_peripheral_monitor_archetypes_get_with_http_info(**kwargs)  # noqa: E501

    @validate_arguments
    def monitor_get_all_archetype_name_v1_peripheral_monitor_archetypes_get_with_http_info(self, **kwargs) -> ApiResponse:  # noqa: E501
        """Monitor Get All Archetype Name  # noqa: E501

        # ✔️ Get all the available user terminal archetype for a given user terminal name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.monitor_get_all_archetype_name_v1_peripheral_monitor_archetypes_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method monitor_get_all_archetype_name_v1_peripheral_monitor_archetypes_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
        }

        return self.api_client.call_api(
            '/v1/peripheral/monitor/archetypes', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def monitor_get_archetype_config_v1_peripheral_monitor_archetype_config_get(self, archetype : StrictStr, **kwargs) -> object:  # noqa: E501
        """Monitor Get Archetype Config  # noqa: E501

        # ✔️ Get the configuration of a given archetype  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.monitor_get_archetype_config_v1_peripheral_monitor_archetype_config_get(archetype, async_req=True)
        >>> result = thread.get()

        :param archetype: (required)
        :type archetype: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the monitor_get_archetype_config_v1_peripheral_monitor_archetype_config_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.monitor_get_archetype_config_v1_peripheral_monitor_archetype_config_get_with_http_info(archetype, **kwargs)  # noqa: E501

    @validate_arguments
    def monitor_get_archetype_config_v1_peripheral_monitor_archetype_config_get_with_http_info(self, archetype : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """Monitor Get Archetype Config  # noqa: E501

        # ✔️ Get the configuration of a given archetype  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.monitor_get_archetype_config_v1_peripheral_monitor_archetype_config_get_with_http_info(archetype, async_req=True)
        >>> result = thread.get()

        :param archetype: (required)
        :type archetype: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'archetype'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method monitor_get_archetype_config_v1_peripheral_monitor_archetype_config_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('archetype') is not None:  # noqa: E501
            _query_params.append(('archetype', _params['archetype']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/v1/peripheral/monitor/archetype_config', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def monitor_impact_v1_peripheral_monitor_get(self, archetype : Optional[StrictStr] = None, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, criteria : Optional[conlist(StrictStr)] = None, **kwargs) -> object:  # noqa: E501
        """Monitor Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.monitor_impact_v1_peripheral_monitor_get(archetype, verbose, duration, criteria, async_req=True)
        >>> result = thread.get()

        :param archetype:
        :type archetype: str
        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param criteria:
        :type criteria: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the monitor_impact_v1_peripheral_monitor_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.monitor_impact_v1_peripheral_monitor_get_with_http_info(archetype, verbose, duration, criteria, **kwargs)  # noqa: E501

    @validate_arguments
    def monitor_impact_v1_peripheral_monitor_get_with_http_info(self, archetype : Optional[StrictStr] = None, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, criteria : Optional[conlist(StrictStr)] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Monitor Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.monitor_impact_v1_peripheral_monitor_get_with_http_info(archetype, verbose, duration, criteria, async_req=True)
        >>> result = thread.get()

        :param archetype:
        :type archetype: str
        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param criteria:
        :type criteria: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'archetype',
            'verbose',
            'duration',
            'criteria'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method monitor_impact_v1_peripheral_monitor_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('archetype') is not None:  # noqa: E501
            _query_params.append(('archetype', _params['archetype']))

        if _params.get('verbose') is not None:  # noqa: E501
            _query_params.append(('verbose', _params['verbose']))

        if _params.get('duration') is not None:  # noqa: E501
            _query_params.append(('duration', _params['duration']))

        if _params.get('criteria') is not None:  # noqa: E501
            _query_params.append(('criteria', _params['criteria']))
            _collection_formats['criteria'] = 'multi'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/v1/peripheral/monitor', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def monitor_impact_v1_peripheral_monitor_post(self, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, archetype : Optional[StrictStr] = None, criteria : Optional[conlist(StrictStr)] = None, monitor : Optional[Monitor] = None, **kwargs) -> object:  # noqa: E501
        """Monitor Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.monitor_impact_v1_peripheral_monitor_post(verbose, duration, archetype, criteria, monitor, async_req=True)
        >>> result = thread.get()

        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param archetype:
        :type archetype: str
        :param criteria:
        :type criteria: List[str]
        :param monitor:
        :type monitor: Monitor
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the monitor_impact_v1_peripheral_monitor_post_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.monitor_impact_v1_peripheral_monitor_post_with_http_info(verbose, duration, archetype, criteria, monitor, **kwargs)  # noqa: E501

    @validate_arguments
    def monitor_impact_v1_peripheral_monitor_post_with_http_info(self, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, archetype : Optional[StrictStr] = None, criteria : Optional[conlist(StrictStr)] = None, monitor : Optional[Monitor] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Monitor Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.monitor_impact_v1_peripheral_monitor_post_with_http_info(verbose, duration, archetype, criteria, monitor, async_req=True)
        >>> result = thread.get()

        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param archetype:
        :type archetype: str
        :param criteria:
        :type criteria: List[str]
        :param monitor:
        :type monitor: Monitor
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'verbose',
            'duration',
            'archetype',
            'criteria',
            'monitor'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method monitor_impact_v1_peripheral_monitor_post" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('verbose') is not None:  # noqa: E501
            _query_params.append(('verbose', _params['verbose']))

        if _params.get('duration') is not None:  # noqa: E501
            _query_params.append(('duration', _params['duration']))

        if _params.get('archetype') is not None:  # noqa: E501
            _query_params.append(('archetype', _params['archetype']))

        if _params.get('criteria') is not None:  # noqa: E501
            _query_params.append(('criteria', _params['criteria']))
            _collection_formats['criteria'] = 'multi'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['monitor'] is not None:
            _body_params = _params['monitor']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/v1/peripheral/monitor', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def peripheral_get_all_categories_v1_peripheral_all_get(self, **kwargs) -> object:  # noqa: E501
        """Peripheral Get All Categories  # noqa: E501

        # ✔️ Get all the available user peripheral router  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.peripheral_get_all_categories_v1_peripheral_all_get(async_req=True)
        >>> result = thread.get()

        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the peripheral_get_all_categories_v1_peripheral_all_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.peripheral_get_all_categories_v1_peripheral_all_get_with_http_info(**kwargs)  # noqa: E501

    @validate_arguments
    def peripheral_get_all_categories_v1_peripheral_all_get_with_http_info(self, **kwargs) -> ApiResponse:  # noqa: E501
        """Peripheral Get All Categories  # noqa: E501

        # ✔️ Get all the available user peripheral router  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.peripheral_get_all_categories_v1_peripheral_all_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method peripheral_get_all_categories_v1_peripheral_all_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
        }

        return self.api_client.call_api(
            '/v1/peripheral/all', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def usb_stick_get_all_archetype_name_v1_peripheral_usb_stick_archetypes_get(self, **kwargs) -> object:  # noqa: E501
        """Usb Stick Get All Archetype Name  # noqa: E501

        # ✔️ Get all the available user terminal archetype for a given user terminal name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.usb_stick_get_all_archetype_name_v1_peripheral_usb_stick_archetypes_get(async_req=True)
        >>> result = thread.get()

        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the usb_stick_get_all_archetype_name_v1_peripheral_usb_stick_archetypes_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.usb_stick_get_all_archetype_name_v1_peripheral_usb_stick_archetypes_get_with_http_info(**kwargs)  # noqa: E501

    @validate_arguments
    def usb_stick_get_all_archetype_name_v1_peripheral_usb_stick_archetypes_get_with_http_info(self, **kwargs) -> ApiResponse:  # noqa: E501
        """Usb Stick Get All Archetype Name  # noqa: E501

        # ✔️ Get all the available user terminal archetype for a given user terminal name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.usb_stick_get_all_archetype_name_v1_peripheral_usb_stick_archetypes_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method usb_stick_get_all_archetype_name_v1_peripheral_usb_stick_archetypes_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
        }

        return self.api_client.call_api(
            '/v1/peripheral/usb_stick/archetypes', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def usb_stick_get_archetype_config_v1_peripheral_usb_stick_archetype_config_get(self, archetype : StrictStr, **kwargs) -> object:  # noqa: E501
        """Usb Stick Get Archetype Config  # noqa: E501

        # ✔️ Get the configuration of a given archetype  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.usb_stick_get_archetype_config_v1_peripheral_usb_stick_archetype_config_get(archetype, async_req=True)
        >>> result = thread.get()

        :param archetype: (required)
        :type archetype: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the usb_stick_get_archetype_config_v1_peripheral_usb_stick_archetype_config_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.usb_stick_get_archetype_config_v1_peripheral_usb_stick_archetype_config_get_with_http_info(archetype, **kwargs)  # noqa: E501

    @validate_arguments
    def usb_stick_get_archetype_config_v1_peripheral_usb_stick_archetype_config_get_with_http_info(self, archetype : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """Usb Stick Get Archetype Config  # noqa: E501

        # ✔️ Get the configuration of a given archetype  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.usb_stick_get_archetype_config_v1_peripheral_usb_stick_archetype_config_get_with_http_info(archetype, async_req=True)
        >>> result = thread.get()

        :param archetype: (required)
        :type archetype: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'archetype'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method usb_stick_get_archetype_config_v1_peripheral_usb_stick_archetype_config_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('archetype') is not None:  # noqa: E501
            _query_params.append(('archetype', _params['archetype']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/v1/peripheral/usb_stick/archetype_config', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def usb_stick_impact_v1_peripheral_usb_stick_get(self, archetype : Optional[StrictStr] = None, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, criteria : Optional[conlist(StrictStr)] = None, **kwargs) -> object:  # noqa: E501
        """Usb Stick Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.usb_stick_impact_v1_peripheral_usb_stick_get(archetype, verbose, duration, criteria, async_req=True)
        >>> result = thread.get()

        :param archetype:
        :type archetype: str
        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param criteria:
        :type criteria: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the usb_stick_impact_v1_peripheral_usb_stick_get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.usb_stick_impact_v1_peripheral_usb_stick_get_with_http_info(archetype, verbose, duration, criteria, **kwargs)  # noqa: E501

    @validate_arguments
    def usb_stick_impact_v1_peripheral_usb_stick_get_with_http_info(self, archetype : Optional[StrictStr] = None, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, criteria : Optional[conlist(StrictStr)] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Usb Stick Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.usb_stick_impact_v1_peripheral_usb_stick_get_with_http_info(archetype, verbose, duration, criteria, async_req=True)
        >>> result = thread.get()

        :param archetype:
        :type archetype: str
        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param criteria:
        :type criteria: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'archetype',
            'verbose',
            'duration',
            'criteria'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method usb_stick_impact_v1_peripheral_usb_stick_get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('archetype') is not None:  # noqa: E501
            _query_params.append(('archetype', _params['archetype']))

        if _params.get('verbose') is not None:  # noqa: E501
            _query_params.append(('verbose', _params['verbose']))

        if _params.get('duration') is not None:  # noqa: E501
            _query_params.append(('duration', _params['duration']))

        if _params.get('criteria') is not None:  # noqa: E501
            _query_params.append(('criteria', _params['criteria']))
            _collection_formats['criteria'] = 'multi'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/v1/peripheral/usb_stick', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def usb_stick_impact_v1_peripheral_usb_stick_post(self, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, archetype : Optional[StrictStr] = None, criteria : Optional[conlist(StrictStr)] = None, usb_stick : Optional[UsbStick] = None, **kwargs) -> object:  # noqa: E501
        """Usb Stick Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.usb_stick_impact_v1_peripheral_usb_stick_post(verbose, duration, archetype, criteria, usb_stick, async_req=True)
        >>> result = thread.get()

        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param archetype:
        :type archetype: str
        :param criteria:
        :type criteria: List[str]
        :param usb_stick:
        :type usb_stick: UsbStick
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: object
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the usb_stick_impact_v1_peripheral_usb_stick_post_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.usb_stick_impact_v1_peripheral_usb_stick_post_with_http_info(verbose, duration, archetype, criteria, usb_stick, **kwargs)  # noqa: E501

    @validate_arguments
    def usb_stick_impact_v1_peripheral_usb_stick_post_with_http_info(self, verbose : Optional[StrictBool] = None, duration : Optional[Union[StrictFloat, StrictInt]] = None, archetype : Optional[StrictStr] = None, criteria : Optional[conlist(StrictStr)] = None, usb_stick : Optional[UsbStick] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Usb Stick Impact  # noqa: E501

        # ✔ Peripheral impacts ### Features  👄 Verbose  🔃 Auto-complete  🔨 Embedded  The impacts values are fix🔌 Usage  * ⏺️  Given  * 📋 Archetype  ⏬ Allocation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.usb_stick_impact_v1_peripheral_usb_stick_post_with_http_info(verbose, duration, archetype, criteria, usb_stick, async_req=True)
        >>> result = thread.get()

        :param verbose:
        :type verbose: bool
        :param duration:
        :type duration: float
        :param archetype:
        :type archetype: str
        :param criteria:
        :type criteria: List[str]
        :param usb_stick:
        :type usb_stick: UsbStick
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(object, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'verbose',
            'duration',
            'archetype',
            'criteria',
            'usb_stick'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method usb_stick_impact_v1_peripheral_usb_stick_post" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('verbose') is not None:  # noqa: E501
            _query_params.append(('verbose', _params['verbose']))

        if _params.get('duration') is not None:  # noqa: E501
            _query_params.append(('duration', _params['duration']))

        if _params.get('archetype') is not None:  # noqa: E501
            _query_params.append(('archetype', _params['archetype']))

        if _params.get('criteria') is not None:  # noqa: E501
            _query_params.append(('criteria', _params['criteria']))
            _collection_formats['criteria'] = 'multi'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['usb_stick'] is not None:
            _body_params = _params['usb_stick']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "object",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/v1/peripheral/usb_stick', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
