# coding: utf-8

"""
    BOAVIZTAPI - DEMO

    <p>🎯 Retrieving the impacts of digital elements.</p> <p>This is a quick demo, to see full documentation <a href=\"https://doc.api.boavizta.org\">click here</a></p> <h2>Features</h2> <p>Bellow a list of all available features.</p> <h3>👄 Verbose</h3> <p>Verbose is an HTTP parameter. If set at true :</p> <ul> <li>Shows the impacts of each component</li> <li>Shows the value used for each attribute</li> </ul> <p><em>\"attribute\": {\"value\": \"value\", \"unit\": \"unit\", \"status\": \"Status\", \"source\": \"Source\", \"min\":\"min\", \"max\":\"max\", \"significant_figures\":\"significant_figures\"}</em></p> <h3>🔨 Embedded</h3> <ul> <li>Embedded impacts are the impacts occurring during raw material extraction, manufacture, distribution and end of life</li> <li>When end of life is not taken into account, we specified it in the <code>warnings</code></li> </ul> <h3>🔌  Usage</h3> <p>Usage impacts are assessed by multiplying :</p> <ul> <li> <p>a <strong>duration</strong></p> </li> <li> <p>an <strong>impact factor</strong> </p> </li> <li> <p>an <strong>electrical consumption</strong> </p> </li> </ul> <h4>⏲ Duration</h4> <p>Usage impacts can be given as a router parameter, in hours.</p> <p>If no duration is given, <strong>the impact is assess for the all life duration of the asset</strong>.</p> <h4>✖️ Impact factors</h4> <ul> <li>Impact factors can be given : <em>\"usage\":{\"elec_factors\":{[criterion]_factors: 0.38}}</em></li> <li> <p>Impact factors can be retrieved from : <em>\"usage\":{\"usage_location\": \"FRA\"}</em>. </p> </li> <li> <p>See the list of locations : <a href=\"/v1/utils/country_code\">/v1/utils/country_code</a>*</p> </li> </ul> <h4>⚡ Electrical consumption</h4> <h5>⏺️ Given</h5> <ul> <li>Electrical consumption can be given for one hour (average) <em>\"usage\":{\"avg_power\": 1}</em>.</li> </ul> <h5>📈 Modeled</h5> <ul> <li>Electrical consumption can be retrieved from consumption profile using <em>usage:{time_workload: 50}</em>.</li> </ul> <h5>📋 Archetype</h5> <ul> <li>In some cases, default electrical consumption can be taken from the archetype</li> </ul> <h3>🔃 Auto-complete &amp; 📋 Archetype</h3> <p>The API will complete the missing attributes in a request with a completion function or with values taken from the <code>archetype</code> specified in the route parameter.</p> <h3>⏬ Allocation</h3> <ul> <li>Usage impacts are assessed on the duration given in route parameter</li> <li>Embedded impacts are allocated linearly on the duration given in parameter <code>embedded_impact = impact * (duration/life_duration)</code></li> </ul> <p>If no duration is given, the life_duration (<code>`hours_life_time</code>) of the asset is used.</p>  # noqa: E501

    The version of the OpenAPI document: 1.0.0a4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import unittest

import boaviztapi_sdk
from boaviztapi_sdk.api.terminal_api import TerminalApi  # noqa: E501
from boaviztapi_sdk.rest import ApiException


class TestTerminalApi(unittest.TestCase):
    """TerminalApi unit test stubs"""

    def setUp(self):
        self.api = boaviztapi_sdk.api.terminal_api.TerminalApi()  # noqa: E501

    def tearDown(self):
        pass

    def test_box_get_all_archetype_name_v1_terminal_box_archetypes_get(self):
        """Test case for box_get_all_archetype_name_v1_terminal_box_archetypes_get

        Box Get All Archetype Name  # noqa: E501
        """
        pass

    def test_box_get_archetype_config_v1_terminal_box_archetype_config_get(self):
        """Test case for box_get_archetype_config_v1_terminal_box_archetype_config_get

        Box Get Archetype Config  # noqa: E501
        """
        pass

    def test_box_impact_v1_terminal_box_get(self):
        """Test case for box_impact_v1_terminal_box_get

        Box Impact  # noqa: E501
        """
        pass

    def test_box_impact_v1_terminal_box_post(self):
        """Test case for box_impact_v1_terminal_box_post

        Box Impact  # noqa: E501
        """
        pass

    def test_desktop_get_all_archetype_name_v1_terminal_desktop_archetypes_get(self):
        """Test case for desktop_get_all_archetype_name_v1_terminal_desktop_archetypes_get

        Desktop Get All Archetype Name  # noqa: E501
        """
        pass

    def test_desktop_get_archetype_config_v1_terminal_desktop_archetype_config_get(self):
        """Test case for desktop_get_archetype_config_v1_terminal_desktop_archetype_config_get

        Desktop Get Archetype Config  # noqa: E501
        """
        pass

    def test_desktop_impact_v1_terminal_desktop_get(self):
        """Test case for desktop_impact_v1_terminal_desktop_get

        Desktop Impact  # noqa: E501
        """
        pass

    def test_desktop_impact_v1_terminal_desktop_post(self):
        """Test case for desktop_impact_v1_terminal_desktop_post

        Desktop Impact  # noqa: E501
        """
        pass

    def test_laptop_get_all_archetype_name_v1_terminal_laptop_archetypes_get(self):
        """Test case for laptop_get_all_archetype_name_v1_terminal_laptop_archetypes_get

        Laptop Get All Archetype Name  # noqa: E501
        """
        pass

    def test_laptop_get_archetype_config_v1_terminal_laptop_archetype_config_get(self):
        """Test case for laptop_get_archetype_config_v1_terminal_laptop_archetype_config_get

        Laptop Get Archetype Config  # noqa: E501
        """
        pass

    def test_laptop_impact_v1_terminal_laptop_get(self):
        """Test case for laptop_impact_v1_terminal_laptop_get

        Laptop Impact  # noqa: E501
        """
        pass

    def test_laptop_impact_v1_terminal_laptop_post(self):
        """Test case for laptop_impact_v1_terminal_laptop_post

        Laptop Impact  # noqa: E501
        """
        pass

    def test_smartphone_get_all_archetype_name_v1_terminal_smartphone_archetypes_get(self):
        """Test case for smartphone_get_all_archetype_name_v1_terminal_smartphone_archetypes_get

        Smartphone Get All Archetype Name  # noqa: E501
        """
        pass

    def test_smartphone_get_archetype_config_v1_terminal_smartphone_archetype_config_get(self):
        """Test case for smartphone_get_archetype_config_v1_terminal_smartphone_archetype_config_get

        Smartphone Get Archetype Config  # noqa: E501
        """
        pass

    def test_smartphone_impact_v1_terminal_smartphone_get(self):
        """Test case for smartphone_impact_v1_terminal_smartphone_get

        Smartphone Impact  # noqa: E501
        """
        pass

    def test_smartphone_impact_v1_terminal_smartphone_post(self):
        """Test case for smartphone_impact_v1_terminal_smartphone_post

        Smartphone Impact  # noqa: E501
        """
        pass

    def test_tablet_get_all_archetype_name_v1_terminal_tablet_archetypes_get(self):
        """Test case for tablet_get_all_archetype_name_v1_terminal_tablet_archetypes_get

        Tablet Get All Archetype Name  # noqa: E501
        """
        pass

    def test_tablet_get_archetype_config_v1_terminal_tablet_archetype_config_get(self):
        """Test case for tablet_get_archetype_config_v1_terminal_tablet_archetype_config_get

        Tablet Get Archetype Config  # noqa: E501
        """
        pass

    def test_tablet_impact_v1_terminal_tablet_get(self):
        """Test case for tablet_impact_v1_terminal_tablet_get

        Tablet Impact  # noqa: E501
        """
        pass

    def test_tablet_impact_v1_terminal_tablet_post(self):
        """Test case for tablet_impact_v1_terminal_tablet_post

        Tablet Impact  # noqa: E501
        """
        pass

    def test_television_get_all_archetype_name_v1_terminal_television_archetypes_get(self):
        """Test case for television_get_all_archetype_name_v1_terminal_television_archetypes_get

        Television Get All Archetype Name  # noqa: E501
        """
        pass

    def test_television_get_archetype_config_v1_terminal_television_archetype_config_get(self):
        """Test case for television_get_archetype_config_v1_terminal_television_archetype_config_get

        Television Get Archetype Config  # noqa: E501
        """
        pass

    def test_television_impact_v1_terminal_television_get(self):
        """Test case for television_impact_v1_terminal_television_get

        Television Impact  # noqa: E501
        """
        pass

    def test_television_impact_v1_terminal_television_post(self):
        """Test case for television_impact_v1_terminal_television_post

        Television Impact  # noqa: E501
        """
        pass

    def test_terminal_get_all_categories_v1_terminal_all_get(self):
        """Test case for terminal_get_all_categories_v1_terminal_all_get

        Terminal Get All Categories  # noqa: E501
        """
        pass


if __name__ == '__main__':
    unittest.main()
